Package org.optaplanner.core.impl.score.buildin.hardsoft

## Class HardSoftScoreHolderImpl

- java.lang.Object
- - org.optaplanner.core.impl.score.holder.AbstractScoreHolder<HardSoftScore>
  - - org.optaplanner.core.impl.score.buildin.hardsoft.HardSoftScoreHolderImpl

- All Implemented Interfaces:
    `HardSoftScoreHolder`, `ScoreHolder<HardSoftScore>`

      public final class HardSoftScoreHolderImpl
      extends AbstractScoreHolder<HardSoftScore>
      implements HardSoftScoreHolder

  See Also:
    `HardSoftScore`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `AbstractScoreHolder.BigDecimalMatchExecutor, AbstractScoreHolder.ConstraintActivationUnMatchListener, AbstractScoreHolder.IntMatchExecutor, AbstractScoreHolder.LongMatchExecutor, AbstractScoreHolder.ScoreMatchExecutor<Score_ extends AbstractScore<Score_>>`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `hardScore` |
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.IntMatchExecutor>` | `matchExecutorByNumberMap` |
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.ScoreMatchExecutor<HardSoftScore>>` | `matchExecutorByScoreMap` | Slower than `matchExecutorByNumberMap`
    `protected int` | `softScore` |

    - ### Fields inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `constraintMatchEnabled, constraintMatchTotalMap, indictmentMap, zeroScore`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HardSoftScoreHolderImpl​(boolean constraintMatchEnabled)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int hardWeight)` |
    `void` | `addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int hardWeight, int softWeight)` |
    `void` | `addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int softWeight)` |
    `void` | `configureConstraintWeight​(org.kie.api.definition.rule.Rule rule, HardSoftScore constraintWeight)` |
    `HardSoftScore` | `extractScore​(int initScore)` |
    `int` | `getHardScore()` |
    `int` | `getSoftScore()` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext)` | Penalize a match by the `ConstraintWeight` negated.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, int hardWeightMultiplier, int softWeightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext)` | Reward a match by the `ConstraintWeight`.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, int hardWeightMultiplier, int softWeightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level.

    - ### Methods inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `extractJustificationList, getConstraintMatchTotalMap, getIndictmentMap, isConstraintMatchEnabled, registerConstraintMatch`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### matchExecutorByNumberMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.IntMatchExecutor> matchExecutorByNumberMap

    - #### matchExecutorByScoreMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.ScoreMatchExecutor<HardSoftScore>> matchExecutorByScoreMap

      Slower than `matchExecutorByNumberMap`

    - #### hardScore

          protected int hardScore

    - #### softScore

          protected int softScore

  - ### Constructor Detail

    - #### HardSoftScoreHolderImpl

          public HardSoftScoreHolderImpl​(boolean constraintMatchEnabled)

  - ### Method Detail

    - #### getHardScore

          public int getHardScore()

    - #### getSoftScore

          public int getSoftScore()

    - #### configureConstraintWeight

          public void configureConstraintWeight​(org.kie.api.definition.rule.Rule rule,
                                                HardSoftScore constraintWeight)

      Overrides:
        `configureConstraintWeight` in class `AbstractScoreHolder<HardSoftScore>`

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Penalize a match by the `ConstraintWeight` negated.
      Specified by:
        `penalize` in interface `ScoreHolder<HardSoftScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               int weightMultiplier)

      Description copied from interface: `HardSoftScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Specified by:
        `penalize` in interface `HardSoftScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               int hardWeightMultiplier,
                               int softWeightMultiplier)

      Description copied from interface: `HardSoftScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level. Slower than `HardSoftScoreHolder.penalize(RuleContext, int)`.
      Specified by:
        `penalize` in interface `HardSoftScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Reward a match by the `ConstraintWeight`.
      Specified by:
        `reward` in interface `ScoreHolder<HardSoftScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             int weightMultiplier)

      Description copied from interface: `HardSoftScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Specified by:
        `reward` in interface `HardSoftScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             int hardWeightMultiplier,
                             int softWeightMultiplier)

      Description copied from interface: `HardSoftScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level. Slower than `HardSoftScoreHolder.reward(RuleContext, int)`.
      Specified by:
        `reward` in interface `HardSoftScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Overrides:
        `impactScore` in class `AbstractScoreHolder<HardSoftScore>`
      Parameters:
        `kcontext` - never null

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  int weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in interface `HardSoftScoreHolder`
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  long weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  BigDecimal weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### addHardConstraintMatch

          public void addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                             int hardWeight)

      Specified by:
        `addHardConstraintMatch` in interface `HardSoftScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - higher is better, negative for a penalty, positive for a reward

    - #### addSoftConstraintMatch

          public void addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                             int softWeight)

      Specified by:
        `addSoftConstraintMatch` in interface `HardSoftScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `softWeight` - higher is better, negative for a penalty, positive for a reward

    - #### addMultiConstraintMatch

          public void addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                              int hardWeight,
                                              int softWeight)

      Specified by:
        `addMultiConstraintMatch` in interface `HardSoftScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - higher is better, negative for a penalty, positive for a reward
        `softWeight` - higher is better, negative for a penalty, positive for a reward

    - #### extractScore

          public HardSoftScore extractScore​(int initScore)

      Specified by:
        `extractScore` in class `AbstractScoreHolder<HardSoftScore>`